<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
      <el-form-item label="部门名称" prop="deptName">
        <el-input
          maxlength="50"
          v-model="queryParams.deptName"
          placeholder="请输入部门名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="info"
          plain
          icon="el-icon-sort"
          size="mini"
          @click="toggleExpandAll"
        >展开/折叠</el-button>
      </el-col>
    </el-row>

    <el-table
      v-if="refreshTable"
      v-loading="loading"
      :data="deptList"
      row-key="deptId"
      :default-expand-all="isExpandAll"
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <el-table-column prop="deptName" label="部门名称" :show-overflow-tooltip="true" width="360"></el-table-column>
      <el-table-column prop="orderNum" label="排序" width="60"></el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handleAdd(scope.row)"
          >新增</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改菜单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="680px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-row>
          <el-col :span="24">
            <el-form-item label="上级部门" prop="parentId">
              <treeselect
                v-model="form.parentId"
                :options="deptOptions"
                :normalizer="normalizer"
                :show-count="true"
                placeholder="选择上级部门"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="部门名称" prop="deptName">
              <el-input v-model="form.deptName" placeholder="请输入部门名称" maxlength="50"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="显示排序" prop="orderNum">
              <el-input-number v-model="form.orderNum" controls-position="right" :min="0" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>

import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import IconSelect from "@/components/IconSelect";
import { debounce } from 'lodash'
export default {
  name: "Menu",
  dicts: ['sys_show_hide', 'sys_normal_disable'],
  components: { Treeselect, IconSelect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 部门表格树数据
      deptList: [],
      // 菜单树选项
      deptOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 是否展开，默认全部折叠
      isExpandAll: false,
      // 重新渲染表格状态
      refreshTable: true,
      // 查询参数
      queryParams: {
        deptName: undefined,
        visible: undefined
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        deptName: [
          { required: true, message: "部门名称不能为空", trigger: "blur" }
        ],
        orderNum: [
          { required: true, message: "部门顺序不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询部门列表 */
    async getList(){
      this.loading = true;
      await this.$axios.get('/sysDeptController/list',{params: this.queryParams}).then((res) => {
        this.deptList = this.handleTree(res.data, "deptId")
        this.loading = false;
      }).catch((error) => {
        this.loading = false;
      })
    },
    /** 转换菜单数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children
      }
      return {
        id: node.deptId,
        label: node.deptName,
        children: node.children
      };
    },
    /** 查询菜单下拉树结构 */
    async getTreeselect() {
      await this.$axios.get('/sysDeptController/list').then((res) => {
        this.deptOptions = []
        const dept = { deptId: 0, deptName: '根节点', children: [] }
        dept.children = this.handleTree(res.data, "deptId")
        this.deptOptions.push(dept)
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        deptId: undefined,
        parentId: 0,
        deptName: undefined,
        orderNum: undefined,
      };
      this.resetForm("form")
    },
    /** 搜索按钮操作 */
    handleQuery:debounce(function(){
      this.getList()
    },200),
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm")
    },
    /** 新增按钮操作 */
    handleAdd:debounce(function(row){
      this.reset()
      this.getTreeselect();
      if (row != null && row.deptId) {
        this.form.parentId = row.deptId
      } else {
        this.form.parentId = 0
      }
      this.open = true
      this.title = "添加部门"
    },200),
    /** 展开/折叠操作 */
    toggleExpandAll() {
      this.refreshTable = false
      this.isExpandAll = !this.isExpandAll
      this.$nextTick(() => {
        this.refreshTable = true
      });
    },
    /** 修改按钮操作 */
    handleUpdate:debounce(async function(row){
      this.reset()
      this.getTreeselect()
      var searchParams = {
        deptId: row.deptId,
      }
      await this.$axios.get('/sysDeptController/getDetailInfo',
        {params: searchParams}).then((res) => {
        this.form = res.data
        this.open = true
        this.title = "修改部门"
      }).catch((error) => {
        // this.$message.error('获取数据出错' + error)
      })
    },200),
    /** 提交按钮 */
    submitForm:debounce(function(){
      this.$refs["form"].validate(async valid => {
        if (valid) {
          if (this.form.deptId != undefined) {
            await this.$axios.post('/sysDeptController/updateDept', this.form).then((res) => {
              if (res.code == 0) {
                this.$message.success('修改成功')
              }
              if (res.code == 1) {
                this.$message.error(res.data)
              }
              this.open = false;
              this.getList();
            }).catch((error) => {
              // this.$message.error(error)
            })
          } else {
            await this.$axios.post('/sysDeptController/addDept', this.form).then((res) => {
              if (res.code == 0) {
                this.$message.success('新增成功')
              }
              if (res.code == 1) {
                this.$message.error(res.data)
              }
              this.open = false;
              this.getList();
            }).catch((error) => {
              // this.$message.error(error)
            })
          }
        }
      });
    },200),
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$confirm('是否确认删除名称为"' + row.deptName + '"的数据项？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
        beforeClose(action, instance, done) {
          if (action === "confirm") {
            instance.$refs["confirm"].$el.onclick = (function (e) {
              e = e || window.event;
              if (e.detail != 0) {
                done();
              }
            })();
          } else {
            done();
          }
        }
      }).then(() => {
        this.doDelete(row)
      }).catch(() => {
      });
    },
    /**
     * 删除提交
     */
    doDelete:debounce(async function(row){
      const param = {
        deptId: row.deptId,
      }
      await this.$axios.post('/sysDeptController/delDept', param).then((res) => {
        if (res.code == 0) {
          this.$message({
            type: 'success',
            message: '删除成功!'
          });
        } else {
          this.$message({
            type: 'error',
            message: res.data
          });
        }
        this.getList();
      }).catch((error) => {
        this.$message({
          type: 'error',
          message: '删除失败!'
        });
        this.loading = false
      })
    },200)
  }
}
</script>
